<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:um="urn:www.oasis-open.org/ubl/uml-model" >
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<xsl:include href="explode.xslt"/>
	
	<xsl:template match="um:abie[um:name = 'Order']">
		<xsl:call-template name="process-ABIE">
			<xsl:with-param name="abie" select="."/>
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template match="um:abie[um:name = 'OrderResponse']">
		<xsl:call-template name="process-ABIE">
			<xsl:with-param name="abie" select="."/>
		</xsl:call-template>
	</xsl:template>

	<!--
	TODO: rather than eliding these association ends, we might want to convert them
	into BBIE's like Identifiers or something
	-->
	<!-- elide ReferenceDocument.OrderResponse when generating an Order doc -->
	<xsl:template match="um:associationEndAssemblyContext[um:predecessors/um:abie/um:name='ReferenceDocument' and um:associationEnd/um:oppositeRoleName='OrderResponse' and (descendant::node()[name()='um:abie' and um:name='Order'])]">
		<!-- do nothing! -->
	</xsl:template>
	<!-- elide Order.PricingComponent always -->
	<xsl:template match="um:associationEndAssemblyContext[um:predecessors/um:abie/um:name='Order' and um:associationEnd/um:oppositeRoleName='PricingComponent']">
		<!-- do nothing! -->
	</xsl:template>
	<!-- elide Pricing.PricingComponent always -->
	<xsl:template match="um:associationEndAssemblyContext[um:predecessors/um:abie/um:name='Pricing' and um:associationEnd/um:oppositeRoleName='PricingComponent']">
		<!-- do nothing! -->
	</xsl:template>
	<!-- elide Party.CarrierShipmentStage association  -->
	<xsl:template match="um:associationEndAssemblyContext[um:predecessors/um:abie/um:name='Party' and um:associationEnd/um:oppositeRoleName='CarrierShipmentStage']">
		<!-- do nothing! -->
	</xsl:template>
	<!-- elide ExchangeRate.Pricing association  -->
	<xsl:template match="um:associationEndAssemblyContext[um:predecessors/um:abie/um:name='ExchangeRate' and um:associationEnd/um:oppositeRoleName='Pricing']">
		<!-- do nothing! -->
	</xsl:template>
	<!-- elide all association ends out of Address -->
	<xsl:template match="um:associationEndAssemblyContext[um:predecessors/um:abie/um:name='Address']">
		<!-- do nothing! -->
	</xsl:template>
	<!-- elide ReferenceDocument.Order when generating an OrderResponse doc -->
	<xsl:template match="um:associationEndAssemblyContext[um:predecessors/um:abie/um:name='ReferenceDocument' and um:associationEnd/um:oppositeRoleName='Order' and (descendant::node()[name()='um:abie' and um:name='OrderResponse'])]">
		<!-- do nothing! -->
	</xsl:template>
</xsl:transform>
