<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" exclude-result-prefixes="ss">
	<xsl:template match="@* | node()">
		<xsl:copy>
			<xsl:apply-templates select="@* | node()"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="//ss:Row">
		<xsl:copy>
			<xsl:call-template name="process-cells">
				<xsl:with-param name="cells" select="ss:Cell"/>
				<xsl:with-param name="previous-index" select="0"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	<xsl:template name="process-cells">
		<xsl:param name="cells" select="/.."/>
		<xsl:param name="previous-index" select="/.."/>
		<xsl:if test="$cells">
			<xsl:choose>
				<xsl:when test="$cells[1]/@ss:Index">
					<xsl:variable name="skipped-cell-count" select="$cells[1]/@ss:Index - $previous-index -1"/>
					<xsl:if test="$skipped-cell-count > 0">
						<xsl:call-template name="fabricate-cells">
							<xsl:with-param name="howmany" select="$skipped-cell-count"/>
						</xsl:call-template>
					</xsl:if>
					<xsl:copy-of select="$cells[1]"/>
					<xsl:call-template name="process-cells">
						<xsl:with-param name="cells" select="$cells[position() > 1]"/>
						<xsl:with-param name="previous-index" select="$cells[1]/@ss:Index"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy-of select="$cells[1]"/>
					<xsl:call-template name="process-cells">
						<xsl:with-param name="cells" select="$cells[position() > 1]"/>
						<xsl:with-param name="previous-index" select="$previous-index + 1"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	<xsl:template name="fabricate-cells">
		<xsl:param name="howmany"/>
		<xsl:if test="$howmany > 0">
			<ss:Cell/>
			<xsl:call-template name="fabricate-cells">
				<xsl:with-param name="howmany" select="$howmany - 1"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
</xsl:transform>
