<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:um="urn:www.oasis-open.org/ubl/uml-model" xmlns:func="http://exslt.org/functions">
<!--
TODO: add dot "clustering": subgraph <cluster-name> { ...}  Cluster on um:abie/um:name so
that variants associated with each name are grouped.  If cluster has only one member then
don't create a cluster - just output the node.
-->
	<xsl:output method="text"/>
	<xsl:include href="lookup-abie.xslt"/>
	<xsl:template match="/">
		digraph G {
		<xsl:apply-templates select="//um:abie"/>
		}
	</xsl:template>
	<xsl:template match="um:abie">
		<xsl:variable name="abie" select="."/>
		<xsl:value-of select="um:quote-identifier(um:abie-variant-identifier($abie))"/>
		<xsl:text>[shape=record, toplabel=</xsl:text>
		<xsl:value-of select="um:quote-identifier(um:abie-variant-identifier($abie))"/>
		<xsl:text>, label="{ </xsl:text>
		<xsl:for-each select="um:property">
			<xsl:text>| </xsl:text>
			<xsl:value-of select="um:property-identifier( current())"/>
		</xsl:for-each>
		<xsl:text> }"</xsl:text>
		<xsl:text>];
		</xsl:text>
		<xsl:for-each select="um:associationEnd">
			<xsl:value-of select="um:quote-identifier(um:abie-variant-identifier($abie))"/>
			<xsl:variable name="opposite-abie" select="//um:abie[um:name=current()/um:oppositeABIEName and um:variantName=current()/um:oppositeABIEVariantName]"/>
			<xsl:if test="count($opposite-abie) &lt; 1">
				<xsl:message><ERROR></ERROR></xsl:message>
			</xsl:if>
			<xsl:text>-&gt;</xsl:text>
			<xsl:value-of select="um:quote-identifier( um:abie-variant-identifier($opposite-abie))"/>
			<!--<xsl:text>[headlabel=</xsl:text>-->
			<xsl:text>[label=</xsl:text>
			"<xsl:value-of select="um:association-end-identifier(current())"/> [<xsl:value-of select="current()/um:oppositeMultiplicity/um:minimum"/>..<xsl:value-of select="current()/um:oppositeMultiplicity/um:maximum"/>]"
			<xsl:text>];
			</xsl:text>
		</xsl:for-each>
	</xsl:template>
	<func:function name="um:quote-identifier">
		<xsl:param name="id" select="/.."/>
		<func:result select="concat(concat('&quot;', $id),'&quot;')"/>
	</func:function>
	<func:function name="um:association-end-identifier">
		<xsl:param name="ae" select="/.."/>
		<func:result select="$ae/um:oppositeRoleName"/>
	</func:function>
	<func:function name="um:property-identifier">
		<xsl:param name="prop" select="/.."/>
		<func:result select="concat(concat($prop/um:name, ':'),$prop/um:oppositeBBIEName)"/>
	</func:function>
</xsl:transform>
