<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:um="urn:www.oasis-open.org/ubl/uml-model" xmlns:exsl="http://exslt.org/common" xmlns:saxon="http://icl.com/saxon" xmlns:func="http://exslt.org/functions" extension-element-prefixes="exsl saxon func">
	<xsl:template match="@* | node()">
		<xsl:copy>
			<xsl:apply-templates select="@* | node()"/>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="um:associationName">
		<xsl:copy>
		<!-- sort this ABIE name and the opposite ABIE name -->
		<xsl:for-each select="../../um:name | ../um:oppositeABIEName">
			<xsl:sort select="."/>
			<xsl:value-of select="concat( ., '-')"/>
		</xsl:for-each>
		<!-- distinguish multiple associations between these two ABIEs -->
		<xsl:value-of select="count(../preceding-sibling::node()[ name() = 'um:associationEnd' and ./um:oppositeABIEName = current()/../um:oppositeABIEName])"/>
		</xsl:copy>
	</xsl:template>
</xsl:transform>