<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:um="urn:www.oasis-open.org/ubl/uml-model" xmlns:exsl="http://exslt.org/common" xmlns:saxon="http://icl.com/saxon" xmlns:func="http://exslt.org/functions" extension-element-prefixes="exsl saxon func">
	<xsl:import href="lookup-abie.xslt"/>
	<xsl:template match="/">
		<node>
			<!--
			TODO: add code to validate output of these test cases so I don't have to vgrep! 
			-->
			<!-- seed the variant set -->
			<xsl:call-template name="new-abie-variant">
				<xsl:with-param name="candidate-abie-variant" select="//um:abie[um:name='DespatchAdvice']"/>
			</xsl:call-template>
			<!-- create a duplicate -->
			<xsl:call-template name="new-abie-variant">
				<xsl:with-param name="candidate-abie-variant" select="//um:abie[um:name='DespatchAdvice']"/>
			</xsl:call-template>
			<!-- create a new variant in a non-empty set -->
			<xsl:call-template name="new-abie-variant">
				<xsl:with-param name="candidate-abie-variant" select="//um:abie[um:name='OrderChange']"/>
			</xsl:call-template>
			<!-- build an DespatchAdvice w/ no properties! -->
			<xsl:variable name="new-da-result-tree-fragment">
				<um:abie>
					<xsl:copy-of select="//um:abie[um:name='DespatchAdvice']/@* | //um:abie[um:name='DespatchAdvice']/node()[name() != 'um:property']"/>
				</um:abie>
			</xsl:variable>
			<xsl:variable name="new-da" select="exsl:node-set($new-da-result-tree-fragment)"/>
			<LOOKINGFOR>
				<xsl:copy-of select="$new-da"/>
			</LOOKINGFOR>
			
			<!-- verify that we don't find this new DespatchAdvice -->
			<xsl:variable name="found" select="um:find-abie($new-da/um:abie)"/>
			<xsl:if test="count($found) > 0">
				<ERROR1>shouldn't have found ABIE</ERROR1>
			</xsl:if>

			<!-- create a new variant of DespatchAdvice -->
			<xsl:call-template name="new-abie-variant">
				<xsl:with-param name="candidate-abie-variant" select="$new-da/um:abie"/>
			</xsl:call-template>
			<xsl:variable name="found2" select="um:find-abie($new-da/um:abie)"/>
			
			<!-- verify that we find the new DespatchAdvice when we look for it with 
			an _identical_ variant -->
			<xsl:if test="count($found2) &lt; 1">
				<ERROR2>should have found ABIE</ERROR2>
			</xsl:if>
			
			<!-- 
			add oppositeABIEVariantName to the associationEnds and verify that we 
			still find the new DespatchAdvice
			-->
			<!-- build an DespatchAdvice w/ no properties - but give variants to the assoc ends! -->
			<xsl:variable name="new-new-da-rtf">
				<xsl:for-each select="//um:abie[um:name='DespatchAdvice']">
				<xsl:copy>
					<xsl:copy-of select="@* | node()[name() != 'um:property' and name() != 'um:associationEnd']"/>
					<xsl:for-each select="um:associationEnd">
						<xsl:copy>
							<xsl:copy-of select="@* | node()[name() != 'um:property' and name() != 'um:associationEnd']"/>
							<um:oppositeABIEVariantName>0</um:oppositeABIEVariantName>
						</xsl:copy>
					</xsl:for-each>
				</xsl:copy>
				</xsl:for-each>
			</xsl:variable>
			<xsl:variable name="new-new-da" select="exsl:node-set($new-new-da-rtf)"/>
			<LOOKINGFOR>
				<xsl:copy-of select="$new-new-da"/>
			</LOOKINGFOR>

			<xsl:if test="count(um:find-abie($new-new-da/um:abie)) &lt; 1">
				<ERROR3>should have found ABIE</ERROR3>
			</xsl:if>
			<xsl:if test="um:find-abie($new-new-da/um:abie) != $found/um:abie">
				<ERROR4>found wrong ABIE <xsl:copy-of select="um:find-abie($new-new-da/um:abie)"/></ERROR4>
			</xsl:if>

		</node>
	</xsl:template>
	<xsl:template match="HOLDING-AREA-FOR-TEST-CODE"/>
</xsl:transform>
