<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:um="urn:www.oasis-open.org/ubl/uml-model" xmlns:func="http://exslt.org/functions" xmlns:saxon="http://icl.com/saxon">
	<!--
TODO: use headlabel, taillabel to separate role labels.  This will involve outputting only 
a single association for each pair of association ends.  Need to group association ends into
pairs and operate on them that way.
-->
	<xsl:output method="text"/>
	<xsl:include href="lookup-abie.xslt"/>
	<xsl:template match="/">
		<!-- bug 239 caused me to change this from graph to digraph -->
		digraph G {
			overlap=scale;
		<xsl:apply-templates select="//um:abie"/>
		<xsl:apply-templates select="//um:association"/>
		}
	</xsl:template>
	<xsl:template match="um:abie">
		<xsl:variable name="abie" select="."/>
		<xsl:value-of select="um:quote-identifier(um:abie-variant-identifier($abie))"/>
		<xsl:text>[shape=record, label="{ </xsl:text>
		<xsl:value-of select="um:abie-variant-identifier($abie)"/>
		<xsl:for-each select="um:property">
			<xsl:text>| </xsl:text>
			<xsl:value-of select="um:property-identifier( current())"/>
		</xsl:for-each>
		<xsl:text> }"</xsl:text>
		<xsl:text>];
		</xsl:text>
	</xsl:template>
	<xsl:template match="um:association">
		<xsl:if test="count(um:associationEnd) > 1">
			<xsl:value-of select="um:quote-identifier(um:associationEnd[1]/um:oppositeABIEName)"/>
			<!-- wanted to use undirected edge here but accrording to neato bug 239 on the graphviz
			sige we need to make the edge directed and set dir=none  -->
			<xsl:text>-></xsl:text>
			<xsl:value-of select="um:quote-identifier(um:associationEnd[2]/um:oppositeABIEName)"/>
			<xsl:text>[dir=none label=</xsl:text>
			<xsl:value-of select="um:quote-identifier(um:name)"/>
			<xsl:text>headlabel=</xsl:text>
			"<xsl:value-of select="um:associationEnd[2]/um:oppositeRoleName"/> [<xsl:value-of select="um:associationEnd[2]/um:oppositeMultiplicity/um:minimum"/>..<xsl:value-of select="um:associationEnd[2]/um:oppositeMultiplicity/um:maximum"/>]"
			<xsl:text>taillabel=</xsl:text>
			"<xsl:value-of select="um:associationEnd[1]/um:oppositeRoleName"/> [<xsl:value-of select="um:associationEnd[1]/um:oppositeMultiplicity/um:minimum"/>..<xsl:value-of select="um:associationEnd[1]/um:oppositeMultiplicity/um:maximum"/>]"
			<xsl:text>];
			</xsl:text>
		</xsl:if>
	</xsl:template>
	<func:function name="um:quote-identifier">
		<xsl:param name="id" select="/.."/>
		<func:result select="concat(concat('&quot;', $id),'&quot;')"/>
	</func:function>
	<func:function name="um:association-end-identifier">
		<xsl:param name="ae" select="/.."/>
		<func:result select="$ae/um:associationName"/>
	</func:function>
	<func:function name="um:property-identifier">
		<xsl:param name="prop" select="/.."/>
		<func:result select="concat(concat($prop/um:name, ':'),$prop/um:oppositeBBIEName)"/>
	</func:function>
</xsl:transform>
